package GO1.DeNO.yorudakara.Onaka.role;

import java.util.HashSet;
import java.util.Set;

import org.aiwolf.common.data.Role;

import GO1.DeNO.yorudakara.Onaka.talk.TalkCO;
import GO1.DeNO.yorudakara.Onaka.talk.TalkDivineWithEvilScore5ver;
import GO1.DeNO.yorudakara.Onaka.talk.TalkVoteWolfbySeer5ver;
import GO1.DeNO.yorudakara.Onaka.target.DivineBasic;
import GO1.DeNO.yorudakara.Onaka.target.DivineByAI;
import GO1.DeNO.yorudakara.Onaka.target.VoteWolfbySeer;
import GO1.DeNO.yorudakara.framework.Day;
import GO1.DeNO.yorudakara.framework.Game;
import GO1.DeNO.yorudakara.framework.GameAgent;

public class SeerRoll5ver extends TFAFBaseRole {

    private Set<GameAgent> divined = new HashSet<>();

    public SeerRoll5ver(Game game) {
        super(game);

        //初日CO
        talkTactics.add(new TalkCO(Role.SEER), 10000, Day.on(1));
        //白判定時、自分のモデルを信じて黒として伝える。
        talkTactics.add(new TalkDivineWithEvilScore5ver(), 9000, Day.any());
        talkTactics.add(new TalkVoteWolfbySeer5ver(), 8000, Day.any());

        //残り人数が3人,CO占いの状況になったら 人狼CO
        if (game.getAlives().size() == 3 && game.getSelf().coRole == Role.SEER) {
            talkTactics.add(new TalkCO(Role.WEREWOLF), 10000, Day.on(2));
        }

        //0日目は勝率の高いAIを占う
        divineTactics.add(new DivineByAI(divined), Day.on(0));
        //1日目以降はEvilScoreの高いエージェントを占う
        divineTactics.add(new DivineBasic(divined), Day.after(1));

        // 自分の黒判定に投票。白を除くもっとも狼らしいエージェントに投票
        voteTactics.add(new VoteWolfbySeer());
        revoteTactics.add(new VoteWolfbySeer());
    }

}
