package GO1.DeNO.yorudakara.Onaka.role;

import GO1.DeNO.yorudakara.Onaka.talk.TalkCO;
import GO1.DeNO.yorudakara.Onaka.talk.TalkVoteByAI;
import GO1.DeNO.yorudakara.Onaka.talk.TalkVoteReadAirLittle;
import GO1.DeNO.yorudakara.Onaka.talk.TalkVoteWolf;
import GO1.DeNO.yorudakara.Onaka.target.RevoteMajority;
import GO1.DeNO.yorudakara.Onaka.target.VoteAsAnnouncedToLive;
import GO1.DeNO.yorudakara.framework.Day;
import GO1.DeNO.yorudakara.framework.Game;
import org.aiwolf.common.data.Role;

public class VillagerRole extends TFAFBaseRole {

    public VillagerRole(Game game) {
        super(game);
        //会話戦略
        //初日最初は勝率の高いAIに投票宣言
        talkTactics.add(new TalkVoteByAI(), 1000, Day.on(1), Repeat.ONCE);
        //二日目以降最初は最も怪しいAgentに投票宣言
        talkTactics.add(new TalkVoteWolf(), 1000, Day.after(2), Repeat.ONCE);
        //以降は場の空気を読んでみる
        talkTactics.add(new TalkVoteReadAirLittle(), 100, Day.any(), Repeat.MULTI);

        //残り人数が3人になったら 人狼CO
        if (game.getAlives().size() == 3 && game.getSelf().coRole == Role.SEER) {
            talkTactics.add(new TalkCO(Role.WEREWOLF), 10000, Day.on(2));
        }

        //投票戦略
        //投票宣言した相手に対して投票する
        voteTactics.add(new VoteAsAnnouncedToLive());
        //再投票では、マジョリティに対して投票する
        revoteTactics.add(new RevoteMajority());
    }

}
