package GO1.DeNO.yorudakara.Onaka.role;

import java.security.SecureRandom;

import org.aiwolf.common.data.Role;

import GO1.DeNO.yorudakara.Onaka.talk.TalkCO;
import GO1.DeNO.yorudakara.Onaka.talk.TalkDivineWhiteRandom;
import GO1.DeNO.yorudakara.Onaka.talk.TalkIdentifiedResultWhite;
import GO1.DeNO.yorudakara.Onaka.talk.TalkVoteLastMaxHate;
import GO1.DeNO.yorudakara.Onaka.talk.TalkVoteWhiteMajority;
import GO1.DeNO.yorudakara.Onaka.talk.TalkVoteWhiteWeak;
import GO1.DeNO.yorudakara.Onaka.talk.WhisperAttackHateCount;
import GO1.DeNO.yorudakara.Onaka.talk.WhisperAttackNotSeerMedium;
import GO1.DeNO.yorudakara.Onaka.talk.WhisperCOMedium;
import GO1.DeNO.yorudakara.Onaka.talk.WhisperCOSeer;
import GO1.DeNO.yorudakara.Onaka.talk.WhisperCOVillager;
import GO1.DeNO.yorudakara.Onaka.talk.WhisperEstimatePossessed;
import GO1.DeNO.yorudakara.Onaka.target.AttackAccordingToMyself;
import GO1.DeNO.yorudakara.Onaka.target.VoteAccordingToMyself;
import GO1.DeNO.yorudakara.framework.Day;
import GO1.DeNO.yorudakara.framework.Game;

public class WerewolfRole extends TFAFBaseRole {

	public WerewolfRole(Game game) {
		super(game);

		int mood = new SecureRandom().nextInt(5);

		if (mood == 0) {
			/* Whisper */
			// 0日目以降:占い師CO宣言
			whisperTactics.add(new WhisperCOSeer(), 10000, Day.on(0));
			// 身内以外に黒出し / 身内に白出しした占い師がいたら estimate POSSESSED
			whisperTactics.add(new WhisperEstimatePossessed(), 9000, Day.any());
			whisperTactics.add(new WhisperAttackHateCount(), 8000, Day.any());
			// 狩人 > 占い師・霊媒師CO以外から狩人率高い者へattack宣言
			whisperTactics.add(new WhisperAttackNotSeerMedium(), 7000, Day.any());

			/* Attck */
			// 基本的に宣言通りにAttack
			// 人狼が1人の時はWhisperが発生しないので、
			// これまで自分たちへのvoteカウントの大きかった生き物attack
			attackTactics.add(new AttackAccordingToMyself());
			reattackTactics.add(new AttackAccordingToMyself());

			/* Talk */
			// 初日1ターン目:占い師CO
			talkTactics.add(new TalkCO(Role.SEER), 10000, Day.on(1));
			// 初日は2ターン目, 2日目以降1ターン目:テキトーに占い結果白
			talkTactics.add(new TalkDivineWhiteRandom(), 500);
			// 1日目3ターン目: 人狼、CO以外からメタ勝率が低い奴を vote 対象と宣言
			talkTactics.add(new TalkVoteWhiteWeak(), 10000, Day.on(1));

			// 2日目以降2ターン目: これまでのvoteカウントの大きかった生き物にvote宣言
			talkTactics.add(new TalkVoteLastMaxHate(), 10000, Day.on(2));
			/* 3ターン目以降:
			 * 身内以外のvote先をカウント。
			 * 最多得票先が人狼なら、票が入っている村人にvote宣言、そうでなければ乗っかる。 */
			talkTactics.add(new TalkVoteWhiteMajority(), 9000, Day.any(), Repeat.MULTI);

			/* Vote */
			// 基本的に宣言通り
			voteTactics.add(new VoteAccordingToMyself());
			revoteTactics.add(new VoteAccordingToMyself());
		} else if (mood == 1) {
			/* Whisper */
			// 0日目以降:霊能者CO宣言
			whisperTactics.add(new WhisperCOMedium(), 10000, Day.on(0));
			// 身内以外に黒出し / 身内に白出しした占い師がいたら estimate POSSESSED
			whisperTactics.add(new WhisperEstimatePossessed(), 9000, Day.any());
			whisperTactics.add(new WhisperAttackHateCount(), 8000, Day.any());
			// 狩人 > 占い師・霊媒師CO以外から狩人率高い者へattack宣言
			whisperTactics.add(new WhisperAttackNotSeerMedium(), 7000, Day.any());

			/* Attck */
			// 基本的に宣言通りにAttack
			// 人狼が1人の時はWhisperが発生しないので、
			// これまで自分たちへのvoteカウントの大きかった生き物attack
			attackTactics.add(new AttackAccordingToMyself());
			reattackTactics.add(new AttackAccordingToMyself());

			/* Talk */
			// 初日1ターン目、霊能者CO
			talkTactics.add(new TalkCO(Role.MEDIUM), 10000, Day.on(1));
			// 1日目2ターン目: 人狼、CO以外からメタ勝率が低い奴を vote 対象と宣言
			talkTactics.add(new TalkVoteWhiteWeak(), 10000, Day.on(1));
			// 2日目以降1ターン目:霊能結果白
			talkTactics.add(new TalkIdentifiedResultWhite(), 500, Day.after(2));
			// 2日目以降2ターン目: これまでのvoteカウントの大きかった生き物にvote宣言
			talkTactics.add(new TalkVoteLastMaxHate(), 10000, Day.on(2));
			/* 3ターン目以降:
			 * 身内以外のvote先をカウント。
			 * 最多得票先が人狼なら、票が入っている村人にvote宣言、そうでなければ乗っかる。 */
			talkTactics.add(new TalkVoteWhiteMajority(), 9000, Day.any(), Repeat.MULTI);

			/* Vote */
			// 基本的に宣言通り
			voteTactics.add(new VoteAccordingToMyself());
			revoteTactics.add(new VoteAccordingToMyself());
		} else {
			//潜伏戦略
			/* Whisper */
			// 0日目以降:村人CO宣言
			whisperTactics.add(new WhisperCOVillager(), 10000, Day.on(0));
			// 身内以外に黒出し / 身内に白出しした占い師がいたら estimate POSSESSED
			whisperTactics.add(new WhisperEstimatePossessed(), 9000, Day.any());
			whisperTactics.add(new WhisperAttackHateCount(), 8000, Day.any());
			// 狩人 > 占い師・霊媒師CO以外から狩人率高い者へattack宣言
			whisperTactics.add(new WhisperAttackNotSeerMedium(), 7000, Day.any());

			/* Attck */
			// 基本的に宣言通りにAttack
			// 人狼が1人の時はWhisperが発生しないので、
			// これまで自分たちへのvoteカウントの大きかった生き物attack
			attackTactics.add(new AttackAccordingToMyself());
			reattackTactics.add(new AttackAccordingToMyself());

			/* Talk */
			/*  村人エージェントに似せる */
			// 1日目1ターン目: 人狼、CO以外からメタ勝率が低い奴を vote 対象と宣言
			talkTactics.add(new TalkVoteWhiteWeak(), 10000, Day.on(1));
			// 2日目以降1ターン目: これまでのvoteカウントの大きかった生き物にvote宣言
			talkTactics.add(new TalkVoteLastMaxHate(), 10000, Day.on(2));
			/* 2ターン目以降:
			 * 身内以外のvote先をカウント。
			 * 最多得票先が人狼なら、票が入っている村人にvote宣言、そうでなければ乗っかる。 */
			talkTactics.add(new TalkVoteWhiteMajority(), 9000, Day.any(), Repeat.MULTI);

			/* Vote */
			// 基本的に宣言通り
			voteTactics.add(new VoteAccordingToMyself());
			revoteTactics.add(new VoteAccordingToMyself());
		}
	}

}
