package GO1.DeNO.yorudakara.Onaka.talk;

import GO1.DeNO.yorudakara.Onaka.model.TFAFGameModel;
import GO1.DeNO.yorudakara.framework.Game;
import GO1.DeNO.yorudakara.framework.GameAgent;
import GO1.DeNO.yorudakara.util.Utils;
import org.aiwolf.client.lib.ContentBuilder;
import org.aiwolf.client.lib.DivinedResultContentBuilder;
import org.aiwolf.client.lib.Topic;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;

import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

/**
 * EvilDcore最下位に黒発言をする
 */
/**
 * 占いCOしている者に偽の黒判定を出す。
 */
public class TalkDivineBlackForSeer extends TFAFTalkTactic {

	@Override
	public ContentBuilder talkImpl(int turn, int skip, int utter, TFAFGameModel model, Game game) {
		GameAgent me = game.getSelf();
		if (!me.talkList.stream().filter(x -> x.getDay() == game.getDay() && x.getTopic() == Topic.DIVINED).collect(Collectors.toList()).isEmpty()) {
			return null;
		}
		Set<GameAgent> seer = game.getAliveOthers().stream().filter(ag -> ag.coRole == Role.SEER).collect(Collectors.toSet());
		Set<GameAgent> my_divine = me.talkList.stream().filter(x -> x.getTopic() == Topic.DIVINED).map(x -> x.getTarget()).collect(Collectors.toSet());
		Agent ret = null;
		if (seer.size() == 2 && seer.stream().filter(x -> x.isAttacked).collect(Collectors.toList()).size() == 1) {
			/* 霊能者COが二人でうち一人が襲撃されていた場合、残りは多分人狼なので避ける */
			return null;
		} else {
			seer.removeAll(my_divine);
			for (GameAgent gameAgent : seer) {
				ret = gameAgent.agent;
				break;
			}
		}
		if (ret != null) {
			return new DivinedResultContentBuilder(ret, Species.WEREWOLF);
		}
		return null;
	}

}
